<template lang="pug">
  div
    div(v-if="line")
      slot
      md-button.md-dense(v-if="!corpus.isRemote" :to="{ path: localePath({ name: 'account-corpora-edit-id', params: { id: corpus.pk } } ) }")
        md-icon edit
        span.ml-1 {{ $t('edit') | capitalize }}
      md-button.md-dense.c-not-allowed(v-else title="The corpus is remote and cannot be edited.")
        md-icon edit
        span.ml-1 {{ $t('edit') | capitalize }}
      md-button.md-dense(@click="deleteAction(corpus.pk)")
        md-icon delete
        span.ml-1 {{ $t('delete') | capitalize }}

    md-menu(v-else md-size="auto" md-direction="bottom-end")
      md-button(md-menu-trigger :class="classes")
        md-icon menu
      md-menu-content
        md-menu-item(v-if="!corpus.isRemote" :to="{ path: localePath({ name: 'account-corpora-edit-id', params: { id: corpus.pk } } ) }")
          span {{ $t('edit') | capitalize }}
          md-icon edit
        md-menu-item(@click="deleteAction(corpus.pk)")
          span {{ $t('delete') | capitalize }}
          md-icon delete
</template>

<script>
import { mapActions } from 'vuex'

import PopoverButton from '~/components/PopoverButton'

export default {
  components: {
    // logic components
    PopoverButton
  },
  props: {
    corpus: {
      type: Object,
      default: () => {},
      required: true
    },
    fab: Boolean,
    line: Boolean
  },
  data() {
    return {
      classes: {
        'md-fab': this.fab,
        'md-icon-button': !this.fab
      }
    }
  },
  methods: {
    ...mapActions('corpora', ['deleteCorpus']),
    async deleteAction(pk) {
      const res = await this.deleteCorpus(pk)
      if (res.success) {
        this.afterDelete()
      } else {
        this.$toast.error(res.errors[0], { icon: 'warning' })
      }
    },
    afterDelete() {
      this.$emit('afterDelete')
    }
  }
}
</script>

<style lang="postcss" scoped>
a.menu-item {
  display: flex;
  align-items: center;

  & i {
    margin-right: 0.3rem;
  }
}
.md-menu-content {
  line-height: 1.5 !important;
}
</style>
